package sun.awt.image;

import java.awt.image.ImageConsumer;

class ConsumerQueue {
   ImageConsumer consumer;
   Thread feeder;
   ImageDecoder decoder;
   ConsumerQueue next;
   boolean interested;
   Object securityContext;
   boolean secure;

   ConsumerQueue(InputStreamImageSource src, ImageConsumer ic) {
      this.consumer = ic;
      this.interested = true;
      if (ic instanceof ImageRepresentation) {
         ImageRepresentation ir = (ImageRepresentation)ic;
         if (ir.image.source != src) {
            throw new SecurityException("ImageRep added to wrong image source");
         } else {
            this.secure = true;
         }
      } else if (ic instanceof ImageInfoGrabber) {
         ImageInfoGrabber ig = (ImageInfoGrabber)ic;
         if (ig.image.source != src) {
            throw new SecurityException("ImageRep added to wrong image source");
         } else {
            this.secure = true;
         }
      } else {
         this.securityContext = System.getSecurityManager().getSecurityContext();
      }
   }

   public String toString() {
      return "[" + this.consumer + " " + this.securityContext + "]";
   }
}
