package sun.awt.image;

import java.awt.image.ImageConsumer;
import java.io.IOException;
import java.io.InputStream;

public abstract class ImageDecoder {
   InputStreamImageSource source;
   InputStream input;

   public ImageDecoder(InputStreamImageSource src, InputStream is) {
      this.source = src;
      this.input = is;
   }

   public abstract boolean catchupConsumer(InputStreamImageSource var1, ImageConsumer var2);

   public abstract void produceImage() throws IOException, ImageFormatException;

   public synchronized void close() {
      if (this.input != null) {
         try {
            this.input.close();
         } catch (IOException var1) {
         }

         this.input = null;
      }

   }
}
